open Util

type modder_level =
	| Fail
	| Warn
	| None

let mode = Hashtbl.create 5

let options = ["SETUP_TRA"     ;"AREA_VARIABLES";"MISSING_EXTERN";"MISSING_RESREF"]

let set_modder str_l =
	debug_modder := true;
	List.iter (fun x -> Hashtbl.replace mode x Warn) options;
	List.iter (fun (s1,s2) ->
		let s2 = match String.uppercase s2 with
			| "NONE" -> None
			| "WARN" -> Warn
			| "FAIL" -> Fail
			| _ -> failwith (Printf.sprintf "Unknown MODDER mode: %s" s2)
		in
		let s1 = String.uppercase s1 in
		(try
			ignore (Hashtbl.find mode s1);
		with _ -> failwith (Printf.sprintf "Unknown MODDER option: %s" s1));
		Hashtbl.replace mode s1 s2
	) str_l
;;

let get = Hashtbl.find mode
;;

List.iter (fun x -> Hashtbl.add mode x None) options

let handle_deb test str =
	if get test <> None then log_and_print "%s" str;
	if get test =  Warn then errors_this_component := true;
	if get test =  Fail then failwith str

let handle_msg test str =
	if get test <> None then log_and_print "%s" str;

